package net.wanji.opt.task.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import io.swagger.annotations.ResponseHeader;
import lombok.extern.slf4j.Slf4j;
import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.opt.task.*;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * </p>
 *
 * @author fengyi
 * @version 1.0
 * @Date 2023-04-08
 */
@RestController
@Slf4j
@RequestMapping("/taskTest")
@Api(value = "TaskControllerTest", description = "", tags = "定时任务测试")
public class TaskControllerTest {

    @Resource
    AnalysisGreenCongestionPeriodWeekTask analysisGreenCongestionPeriodWeekTask;
    @Resource
    AnalysisProblemAndStrategyDayTask analysisProblemAndStrategyDayTask;
    @Resource
    AnalysisProblemCrossDayTask analysisProblemCrossDayTask;
    @Resource
    AnalysisProblemCrossDirHourTask analysisProblemCrossDirHourTask;
    @Resource
    AnalysisProblemDayTask analysisProblemDayTask;
    @Resource
    AnalysisProblemHourTask analysisProblemHourTask;
    @Resource
    GreenWaveWeekDataTask greenWaveWeekDataTask;
    @Resource
    ReportGreenAndCrossOptimizeStatisticTask reportGreenAndCrossOptimizeStatisticTask;


    @GetMapping("/request")
    public JsonViewObject list(int type) {
        try {
            JsonViewObject jsonViewObject = JsonViewObject.newInstance();
            if (type == 1) {
                //TODO 待验证
                analysisGreenCongestionPeriodWeekTask.task();
            }
            if (type == 2) {
                analysisGreenCongestionPeriodWeekTask.taskDay();
            }
            if (type == 3) {
                analysisGreenCongestionPeriodWeekTask.insertCrossSlowRunEventData();
            }
//============================================================//
            if (type == 5) {
                analysisProblemAndStrategyDayTask.taskCross();
            }
            if (type == 6) {
                analysisProblemAndStrategyDayTask.taskGreen();;
            }
            //================================================//
            if (type == 7) {
                analysisProblemCrossDayTask.executeGreenCrossHourTask();;
            }
            if (type == 8) {
                analysisProblemCrossDayTask.executeWeeklyTask();
            }
            //=================================================
            if (type == 9) {
                //TODO 异常
                analysisProblemCrossDirHourTask.executeCrossOverFlowTask();
            }
            if (type == 10) {
                analysisProblemDayTask.task();
            }
            if (type == 11) {
                analysisProblemHourTask.task();
            }
            if (type == 12) {
                greenWaveWeekDataTask.executeWeeklyTask();
            }
            if (type == 13) {
                reportGreenAndCrossOptimizeStatisticTask.optimizeDurationCal();
            }
            if (type == 14) {
                reportGreenAndCrossOptimizeStatisticTask.optimizeGreenWaveDurationCal();
            }


            return jsonViewObject.success();
        } catch (Exception e) {
            log.error("", e);
            return JsonViewObject.newInstance().fail("请求失败");
        }

    }


}
